/*
 **	\file IOClass.cpp
 **	\date  2006-04-20
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
class IOClass : public ParserIO
{
public:
	IOClass()
	:socket(0)
	{}
	void read_text(char *,int *);
	void write_text(char *,int);
	void set_socket(int s) {
		socket = s;
	}
	void set_parser(Parser *p) {
		parser = p;
	}

private:
	Parser *parser;
	int socket;	// socket
};

void IOClass::read_text(char *s,int *l)
{
	fd_set rfds;
	int n;

	FD_ZERO(&rfds);
	FD_SET(socket, &rfds);
	n = select(socket + 1, &rfds, NULL, NULL, NULL);
	if (n == -1)
	{
		perror("select() failed");
		parser -> m_next_line = NULL;
		return;
	}
	else
	if (!n)		// huh
	{
		printf("select() returns 0 (?)\n");
		parser -> m_next_line = NULL;
		return;
	}
	if (FD_ISSET(socket, &rfds))
	{
		*l = read(socket, s, *l);
		if (*l == -1)
		{
			perror("read() failed");
			parser -> m_next_line = NULL;
		}
		else
		if (*l == 0)
		{
			parser -> m_next_line = NULL;
		}
		else
		{
			printf("read() returns %d\n",*l);
			while (s[strlen(s) - 1] == 13 || s[strlen(s) - 1] == 10)
				s[strlen(s) - 1] = 0;
		}
	}
	else
	{
		printf("socket did not release select() call\n");
		parser -> m_next_line = NULL;
	}
}

void IOClass::write_text(char *s,int l)
{
	if (write(socket, s, l) == -1)
	{
		perror("write() failed");
	}
}

