/*
 **	\file Parser.h
 **	\date  2006-04-20
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2006  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _PARSER_H
#define _PARSER_H

//#include <map>

#define OBUFSIZE 1024

#define THIS ((Parser *)parser)


class ParserIO;

class Parser
{
public:
	Parser();
	Parser(char *program);
	~Parser();

	void strupr(char *);
	void addlist(void *,void *);
	void removelist(void *,void *);
	void read_file(char *);
	void write_file();
	VARIABLE *reg_variable(char *name,EXPRLIST *p);
	void verify_filename(char *s);
	void text_output(char *s);
	void pprintf(char *format, ...);
	void file_input(char *s,int l);
	void get_data(char *s);
	void read_data(VARLIST *vl);
	void SetParserIO(ParserIO *);
	void flush_obuf();
	int inputstring(char *,int);
	void save_variables();
	void load_variables();
	VARIABLE *get_variable(char *name);
	int peek(int);
	void poke(int,int);
	void execute(void);
	void finish(void);
	void cmd(char *s);
	int editcmd(char *s);

	ParserIO *m_pclParserIO;
	FILE *m_fil;
	LINE *m_linebase;
	LINE *m_current_line;
	LINE *m_next_line;
	LINE *m_onerror;
	NEXT *m_nextbase;
	DATA *m_database;
	DATA *m_current_data;
	SUB *m_subbase;
	FUNC *m_funcbase;
	VARIABLE *m_placeholder;
	int m_running;
	int m_the_ptr;
	int m_file_read;
	int m_file_write;
	int m_tab_pos;
	int m_dataptr;
	char m_run_program[40];
	char m_the_str[1024];
	char m_programname[40];
	char m_program_cwd[200];
//	map<int,int> m_mem;

private:
	VARIABLE *m_variablebase;
	OPEN *m_openbase;
	int m_obufptr;
	int m_load_ok;
	char m_obuf[OBUFSIZE];
};


#endif // _PARSER_H
